`timescale 1ns / 1ps

module fsm(
    output reg cap_enable,
    output reg shift_enable,
    input clk,
    input rst_n,
    input cap,
    input shift
    );
    reg [1:0] state;
    reg [1:0] next_state;
    
    always@*
        case(state)
            2'b00:
              if(cap)
                begin
                next_state = 2'b10;
                cap_enable = 1;
                shift_enable = 0;
                end
              else if(shift)
                begin
                next_state = 2'b01;
                cap_enable = 0;
                shift_enable = 1;
                end
              else
                begin
                next_state = 2'b00;
                cap_enable = 0;
                shift_enable = 0;
                end
            2'b01:
              if(cap)
                begin
                next_state = 2'b11;
                cap_enable = 1;
                shift_enable = 1;
                end
              else if(shift)
                begin
                next_state = 2'b01;
                cap_enable = 0;
                shift_enable = 1;
                end
              else
                begin
                next_state = 2'b00;
                cap_enable = 0;
                shift_enable = 0;
                end
            2'b10:
              if(cap)
                begin
                next_state = 2'b00;
                cap_enable = 0;
                shift_enable = 0;
                end
              else if(shift)
                begin
                next_state = 2'b11;
                cap_enable = 1;
                shift_enable = 1;
                end
              else
                begin
                next_state = 2'b10;
                cap_enable = 1;
                shift_enable = 0;
                end
            2'b11:
              if(cap)
                begin
                next_state = 2'b01;
                cap_enable = 0;
                shift_enable = 1;
                end
              else if(shift)
                begin
                next_state = 2'b11;
                cap_enable = 1;
                shift_enable = 1;
                end
              else
                begin
                next_state = 2'b10;
                cap_enable = 1;
                shift_enable = 0;
                end
            default:
                begin
                next_state = 2'b00;
                cap_enable = 0;
                shift_enable = 0;
                end
            endcase
            
    always@(posedge clk or negedge rst_n)
        if(~rst_n) state <= 2'b00;
        else state <= next_state;
        
endmodule