`timescale 1ns / 1ps

module lab8_4(
    output reg [15:0] light,
    inout wire PS2_DATA,
	inout wire PS2_CLK,
    input wire rst_n,
	input wire clk
    );
    wire [511:0] key_down; wire [8:0] last_change; wire key_valid;
    wire [7:0] num; reg [7:0] num_save;
    reg cap, shift; wire cap_enable, shift_enable;
    
    always@*
        if(key_valid && key_down[last_change] == 0 && last_change == 9'h58)
            begin
            cap = 1;
            shift = 0;
            end
        else if(key_down[9'h12] || key_down[9'h59])
            begin
            cap = 0;
            shift = 1;
            end
        else 
            begin
            cap = 0;
            shift = 0;
            end
    always@*
	    if(key_valid) num_save = num;
	    else num_save = num_save;
	always@*
	    if(cap_enable ^ shift_enable && key_down!= 0 && num_save > 0) light = {cap_enable, shift_enable, 6'b0, num_save - 8'd32};
	    else if(key_down != 0) light = {cap_enable, shift_enable, 6'b0, num_save};
	    else light = {cap_enable, shift_enable, 14'b0};
    KeyboardDecoder U_keyboard(
	  .key_down(key_down),
	  .last_change(last_change),
	  .key_valid(key_valid),
	  .PS2_DATA(PS2_DATA),
	  .PS2_CLK(PS2_CLK),
	  .rst(~rst_n),
	  .clk(clk)
    );
    fsm U_fsm(
      .cap_enable(cap_enable),
      .shift_enable(shift_enable),
      .clk(clk),
      .rst_n(rst_n),
      .cap(cap),
      .shift(shift)
    );
    change U_change(
      .num(num),
      .last_change(last_change)
    );
endmodule
